Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Sony.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Sony.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Sony.pm	(revision 34921)
@@ -751,11 +2989,1158 @@
             6 => 'Night View/Portrait',
             8 => 'B&W',
-            9 => 'Adobe RGB', # A900
+            9 => 'Adobe RGB', # A700
             11 => 'Neutral',
             12 => 'Clear', #7
             13 => 'Deep', #7
             14 => 'Light', #7
-            15 => 'Autumn', #7
+            15 => 'Autumn Leaves', #7
             16 => 'Sepia', #7
+        },
+    },
+    0x6d => {
+        Name => 'ISOSetting',
+        ValueConv => '$val ? exp(($val/8-6)*log(2))*100 : $val',
+        ValueConvInv => '$val ? 8*(log($val/100)/log(2)+6) : $val',
+        PrintConv => '$val ? sprintf("%.0f",$val) : "Auto"',
+        PrintConvInv => '$val =~ /auto/i ? 0 : $val',
+    },
+    0x6f => {
+        Name => 'ISO',
+        ValueConv => '$val ? exp(($val/8-6)*log(2))*100 : $val',
+        ValueConvInv => '$val ? 8*(log($val/100)/log(2)+6) : $val',
+        PrintConv => '$val ? sprintf("%.0f",$val) : "Auto"',
+        PrintConvInv => '$val =~ /auto/i ? 0 : $val',
+    },
+    0x77 => { #JR
+        Name => 'DynamicRangeOptimizerMode',
+        PrintConv => {
+            0 => 'Off',
+            1 => 'Standard',
+            2 => 'Advanced Auto',
+            3 => 'Advanced Level',
+        },
+    },
+    0x79 => 'DynamicRangeOptimizerLevel',
+#    0x06f1 - int16u    LensType,  Condition => '$$self{Model} =~ /^DSLR-A(700|850|900)$/',
+#    0x4a81 - int16u    LensType,  Condition => '$$self{Model} !~ /^DSLR-A(700|850|900)$/',
+#    0x4a84 - int16uRev LensType,  Condition => '$$self{Model} =~ /^DSLR-A(700|850|900)$/',
+    0x0846 => { #13
+        Name => 'ShutterCount', # (=ImageCount for these models)
+        Condition => '$$self{Model} =~ /^DSLR-A(230|290|330|380|390|850|900)$/',
+        Format => 'int32u',
+        Notes => 'only valid for some DSLR models',
+        RawConv => '$val & 0x00ffffff', #PH
+    },
+    0x09bb => { #PH (validated only for DSLR-A850)
+        Name => 'FocusPosition',
+        Condition => '$$self{Model} =~ /^DSLR-A(200|230|290|300|330|350|380|390|700|850|900)$/',
+        Notes => 'only valid for some DSLR models',
+        # 128 = infinity -- see Composite:FocusDistance below
+    },
+    0x1110 => { # (9600 bytes: 4 sets of 40x30 int16u values in the range 0-8191)
+        Name => 'TiffMeteringImage',
+        Format => 'undef[9600]',
+        Notes => q{
+            13-bit RBGG (?) 40x30 pixels, presumably metering info, extracted as a
+            16-bit TIFF image;
+        },
+        ValueConv => sub {
+            my ($val, $et) = @_;
+            return undef unless length $val >= 9600;
+            return \ "Binary data 7404 bytes" unless $et->Options('Binary');
+            my @dat = unpack('n*', $val);
+            # TIFF header for a 16-bit RGB 10dpi 40x30 image
+            $val = Image::ExifTool::MakeTiffHeader(40,30,3,16,10);
+            # re-order data to RGB pixels
+            my ($i, @val);
+            for ($i=0; $i<40*30; ++$i) {
+                # data is 13-bit (max 8191), shift left to fill 16 bits
+                # (typically, this gives a very dark image since the data should
+                # really be anti-logged to convert from EV to perceived brightness)
+#                push @val, $dat[$i]<<3, $dat[$i+2400]<<3, $dat[$i+1200]<<3;
+                push @val, int(5041.1*log($dat[$i]+1)/log(2)), int(5041.1*log($dat[$i+2400]+1)/log(2)), int(5041.1*log($dat[$i+1200]+1)/log(2));
+            }
+            $val .= pack('v*', @val);   # add TIFF strip data
+            return \$val;
+        },
+    },
+);
+
+# more camera setting information (ref JR)
+# - many of these tags are the same as in CameraSettings3
+%Image::ExifTool::Sony::MoreInfo = (
+    PROCESS_PROC => \&ProcessMoreInfo,
+    WRITE_PROC => \&ProcessMoreInfo,
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    NOTES => q{
+        More camera settings information decoded for the A450, A500, A550, A560,
+        A580, A33, A35, A55, NEX-3/5/C3 and VG10E.
+    },
+    0x0001 => { # (256 bytes)
+        Name => 'MoreSettings',
+        SubDirectory => { TagTable => 'Image::ExifTool::Sony::MoreSettings' },
+    },
+    # (byte sizes for a single A580 image -- not checked for other images)
+    0x0002 => [ # (256 bytes)
+        {
+            Name => 'FaceInfo',
+            Condition => '$$self{Model} !~ /^DSLR-(A450|A500|A550)$/',
+            SubDirectory => { TagTable => 'Image::ExifTool::Sony::FaceInfo' },
+        },{
+            Name => 'FaceInfoA',
+            Condition => '$$self{Model} =~ /^DSLR-(A450|A500|A550)$/',
+            SubDirectory => { TagTable => 'Image::ExifTool::Sony::FaceInfoA' },
+        },
+    ],
+    # 0x0101:  512 bytes
+    # 0x0102: 1804 bytes
+    # 0x0103:  176 bytes
+    # 0x0104: 1088 bytes
+    # 0x0105:  160 bytes (all zero unless flash is used, ref JR)
+    # 0x0106:  256 bytes (faces detected if first byte is non-zero? ref JR)
+    0x0107 => { # (7200 bytes: 3 sets of 40x30 int16u values in the range 0-1023)
+        Name => 'TiffMeteringImage',
+        Notes => q{
+            10-bit RGB data from the 1200 AE metering segments, extracted as a 16-bit
+            TIFF image
+        },
+        ValueConv => sub {
+            my ($val, $et) = @_;
+            return undef unless length $val >= 7200;
+            return \ "Binary data 7404 bytes" unless $et->Options('Binary');
+            my @dat = unpack('v*', $val);
+            # TIFF header for a 16-bit RGB 10dpi 40x30 image
+            $val = Image::ExifTool::MakeTiffHeader(40,30,3,16,10);
+            # re-order data to RGB pixels
+            my ($i, @val);
+            for ($i=0; $i<40*30; ++$i) {
+                # data is 10-bit (max 1023), shift left to fill 16 bits
+                # (typically, this gives a very dark image since the data should
+                # really be anti-logged to convert from EV to perceived brightness)
+                push @val, $dat[$i]<<6, $dat[$i+1200]<<6, $dat[$i+2400]<<6;
+            }
+            $val .= pack('v*', @val);   # add TIFF strip data
+            return \$val;
+        },
+    },
+    # 0x0108:  140 bytes
+    # 0x0109:  256 bytes
+    # 0x010a:  256 bytes
+    # 0x0306:  276 bytes
+    # 0x0307:  256 bytes
+    # 0x0308:   96 bytes
+    # 0x0309:  112 bytes
+    # 0xffff:  788 bytes
+    0x0201 => { # (368 bytes)
+        Name => 'MoreInfo0201',
+        SubDirectory => { TagTable => 'Image::ExifTool::Sony::MoreInfo0201' },
+    },
+    # 0x0202:  144 bytes
+    # 0x0401: 4608 bytes
+    0x0401 => {
+        Name => 'MoreInfo0401',
+        SubDirectory => { TagTable => 'Image::ExifTool::Sony::MoreInfo0401' },
+    },
+);
+
+%Image::ExifTool::Sony::MoreInfo0201 = (
+    %binaryDataAttrs,
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    PRIORITY => 0,
+#    0x005d - also from 0 - 255, in sync with but lower than 0x005e, depending on FocalLength
+#    0x005e => {
+#        # FocusPosition for A560/A580/A33/A35/A55V
+#        # seen values from 80 - 255 (= infinity) -- see Composite:FocusDistance2 below
+#        Name => 'FocusPosition2_0201',
+#        Condition => '$$self{Model} !~ /^(NEX-|DSLR-(A450|A500|A550)$)/',
+#    },
+#    0x0093 - also from 0 - 255, in sync with but lower than 0x0094, depending on FocalLength
+#    0x0094 => {
+#        # FocusPosition for A450/A500/A550
+#        # seen values from 80 - 255 (= infinity) -- see Composite:FocusDistance2 below
+#        Name => 'FocusPosition2_0201',
+#        Condition => '$$self{Model} =~ /^(DSLR-(A450|A500|A550)$)/',
+#    },
+    0x011b => { #13
+        Name => 'ImageCount',
+        Condition => '$$self{Model} !~ /^DSLR-A(450|500|550)$/', #JR
+        Format => 'int32u',
+        Notes => 'not valid for the A450, A500 or A550',
+        RawConv => '$val & 0x00ffffff',
+    },
+    0x0125 => { #13
+        Name => 'ShutterCount',
+        Condition => '$$self{Model} !~ /^DSLR-A(450|500|550)$/', #JR
+        Format => 'int32u',
+        Notes => 'not valid for the A450, A500 or A550',
+        RawConv => '$val & 0x00ffffff',
+    },
+    0x014a => { #13
+        Name => 'ShutterCount', # (=ImageCount for these models)
+        Condition => '$$self{Model} =~ /^DSLR-A(450|500|550)$/', #JR
+        Format => 'int32u',
+        Notes => 'A450, A500 and A550 only',
+        RawConv => '$val & 0x00ffffff',
+    },
+);
+
+%Image::ExifTool::Sony::MoreInfo0401 = (
+    %binaryDataAttrs,
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    PRIORITY => 0,
+    0x044e => { #JR
+        Name => 'ShotNumberSincePowerUp',
+        Condition => '$$self{Model} !~ /^NEX-(3|5)$/',
+        Format => 'int32u',
+        Notes => 'Not valid for the NEX-3 or NEX-5',
+        RawConv => '$val & 0x00ffffff',
+    },
+#    0x101e - int16u LensType  Condition => '$$self{Model} =~ /^SLT-A(33|55V)/',
+#    0x1022 - int16u LensType  Condition => '$$self{Model} =~ /^DSLR-A(560|580)/',
+#    0x102a - int16u LensType  Condition => '$$self{Model} =~ /^(SLT-A35|NEX-C3)/',
+
+#    0x10a8 - int16u LensType  Condition => '$$self{Model} =~ /^SLT-A(33|55V)/',
+#    0x10ac - int16u LensType  Condition => '$$self{Model} =~ /^DSLR-A(560|580)/',
+#    0x10b4 - int16u LensType  Condition => '$$self{Model} =~ /^(SLT-A35|NEX-C3)/',
+#
+#    0x10f7 - int16u LensType  Condition => '$$self{Model} =~ /^SLT-A(33|55V)/',
+#    0x10fb - int16u LensType  Condition => '$$self{Model} =~ /^DSLR-A(560|580)/',
+#    0x1103 - int16u LensType  Condition => '$$self{Model} =~ /^(SLT-A35|NEX-C3)/',
+#
+#    0x1181 - int16u LensType  Condition => '$$self{Model} =~ /^SLT-A(33|55V)/',
+#    0x1185 - int16u LensType  Condition => '$$self{Model} =~ /^DSLR-A(560|580)/',
+#    0x118d - int16u LensType  Condition => '$$self{Model} =~ /^(SLT-A35|NEX-C3)/',
+);
+
+# more camera setting information (ref JR)
+# - many of these tags are the same as in CameraSettings3
+%Image::ExifTool::Sony::MoreSettings = (
+    %binaryDataAttrs,
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    PRIORITY => 0,
+    0x01 => { # interesting: somewhere between CameraSettings3 0x04 and 0x34
+        Name => 'DriveMode2',
+        PrintHex => 1,
+        PrintConv => {
+            0x10 => 'Single Frame',
+            0x21 => 'Continuous High', # also automatically selected for Scene mode Sports-action (0x05=52)
+            0x22 => 'Continuous Low',
+            0x30 => 'Speed Priority Continuous',
+            0x51 => 'Self-timer 10 sec',
+            0x52 => 'Self-timer 2 sec, Mirror Lock-up',
+            0x71 => 'Continuous Bracketing 0.3 EV',
+            0x75 => 'Continuous Bracketing 0.7 EV',
+            0x91 => 'White Balance Bracketing Low',
+            0x92 => 'White Balance Bracketing High',
+            0xc0 => 'Remote Commander',
+        },
+    },
+    0x02 => {
+        Name => 'ExposureProgram',
+        SeparateTable => 'ExposureProgram2',
+        PrintConv => \%sonyExposureProgram2,
+    },
+    0x03 => {
+        Name => 'MeteringMode',
+        PrintConv => {
+            1 => 'Multi-segment',
+            2 => 'Center-weighted average',
+            3 => 'Spot',
+        },
+    },
+    0x04 => {
+        Name => 'DynamicRangeOptimizerSetting',
+        PrintConv => {
+            1 => 'Off',
+            16 => 'On (Auto)',
+            17 => 'On (Manual)',
+        },
+    },
+    0x05 => 'DynamicRangeOptimizerLevel',
+    0x06 => {
+        Name => 'ColorSpace',
+        PrintConv => {
+            1 => 'sRGB',
+            2 => 'Adobe RGB',
+        },
+    },
+    0x07 => {
+        Name => 'CreativeStyleSetting',
+        PrintConvColumns => 2,
+        PrintConv => {
+            16 => 'Standard',
+            32 => 'Vivid',
+            64 => 'Portrait',
+            80 => 'Landscape',
+            96 => 'B&W',
+            160 => 'Sunset',
+        },
+    },
+    0x08 => { #JR
+        Name => 'ContrastSetting',
+        Format => 'int8s',
+        PrintConv => '$val > 0 ? "+$val" : $val',
+        PrintConvInv => '$val',
+    },
+    0x09 => {
+        Name => 'SaturationSetting',
+        Format => 'int8s',
+        PrintConv => '$val > 0 ? "+$val" : $val',
+        PrintConvInv => '$val',
+    },
+    0x0a => {
+        Name => 'SharpnessSetting',
+        Format => 'int8s',
+        PrintConv => '$val > 0 ? "+$val" : $val',
+        PrintConvInv => '$val',
+    },
+    0x0d => {
+        Name => 'WhiteBalanceSetting',
+        # many guessed, based on "logical system" as observed for Daylight and Shade and steps of 16 between the modes
+        PrintHex => 1,
+        PrintConvColumns => 2,
+        PrintConv => \%whiteBalanceSetting,
+        SeparateTable => 1,
+    },
+    0x0e => {
+        Name => 'ColorTemperatureSetting',
+        # matches "0xb021 ColorTemperature" when WB set to "Custom" or "Color Temperature/Color Filter"
+        ValueConv => '$val * 100',
+        ValueConvInv => '$val / 100',
+        PrintConv => '"$val K"',
+        PrintConvInv => '$val =~ s/ ?K$//i; $val',
+    },
+    0x0f => {
+        Name => 'ColorCompensationFilterSet',
+        # seen 0, 1-9 and 245-255, corresponding to 0, M1-M9 and G9-G1 on camera display
+        # matches "0xb022 ColorCompensationFilter" when WB set to "Custom" or "Color Temperature/Color Filter"
+        Format => 'int8s',
+        Notes => 'negative is green, positive is magenta',
+        PrintConv => '$val > 0 ? "+$val" : $val',
+        PrintConvInv => '$val',
+    },
+    0x10 => {
+        Name => 'FlashMode',
+        PrintConvColumns => 2,
+        PrintConv => {
+            1 => 'Flash Off',
+            16 => 'Autoflash',
+            17 => 'Fill-flash',
+            18 => 'Slow Sync',
+            19 => 'Rear Sync',
+            20 => 'Wireless',
+        },
+    },
+    0x11 => {
+        Name => 'LongExposureNoiseReduction',
+        PrintConv => {
+            1 => 'Off',
+            16 => 'On',  # (unused or dark subject)
+        },
+    },
+    0x12 => {
+        Name => 'HighISONoiseReduction',
+        PrintConv => {
+            16 => 'Low',
+            17 => 'High',
+            19 => 'Auto',
+        },
+    },
+    0x13 => { # why is this not valid for A450/A500/A550 ?
+        Name => 'FocusMode',
+        Condition => '$$self{Model} !~ /^DSLR-(A450|A500|A550)$/',
+        PrintConv => {
+            17 => 'AF-S',
+            18 => 'AF-C',
+            19 => 'AF-A',
+            32 => 'Manual',
+            48 => 'DMF', #(NC) (seen for NEX-5)
+        },
+    },
+    0x15 => {
+        Name => 'MultiFrameNoiseReduction',
+        Condition => '$$self{Model} !~ /^DSLR-(A450|A500|A550)$/',
+        PrintConv => {
+            0 => 'n/a', # seen for A450/A500/A550
+            1 => 'Off',
+            16 => 'On',
+            255 => 'None', # seen for NEX-3/5/C3
+        },
+    },
+    0x16 => {
+        Name => 'HDRSetting',
+        PrintConv => {
+            1 => 'Off',
+            16 => 'On (Auto)',
+            17 => 'On (Manual)',
+        },
+    },
+    0x17 => {
+        Name => 'HDRLevel',
+        PrintConvColumns => 3,
+        PrintConv => {
+            33 => '1 EV',
+            34 => '1.5 EV', #JR (NC)
+            35 => '2 EV',
+            36 => '2.5 EV', #JR (NC)
+            37 => '3 EV',
+            38 => '3.5 EV', #PH (NC)
+            39 => '4 EV',
+            40 => '5 EV',
+            41 => '6 EV',
+        },
+    },
+    0x18 => {
+        Name => 'ViewingMode',
+        PrintConv => {
+            16 => 'ViewFinder',
+            33 => 'Focus Check Live View',
+            34 => 'Quick AF Live View',
+        },
+    },
+    0x19 => {
+        Name => 'FaceDetection',
+        PrintConv => {
+            1 => 'Off',
+            16 => 'On',
+        },
+    },
+    0x1a => {
+        Name => 'CustomWB_RBLevels',
+        # matches "0x7313 WB_RGGBLevels" when WB set to "Custom", except factor of 4
+        Format => 'int16uRev[2]',
+    },
+    # From here different and overlapping offsets for 3 groups of cameras:
+    # 1) DSLR-A450/A500/A550
+    # 2) NEX-3/5/5C
+    # 3) DSLR-A560/A580, NEX-C3/VG10/VG10E, SLT-A33/A35/A55V
+    0x1e => [{
+        Name => 'BrightnessValue',
+        Condition => '$$self{Model} =~ /^DSLR-(A450|A500|A550)/',
+        Notes => 'A450, A500 and A550',
+        ValueConv => '($val-106)/8',
+        ValueConvInv => '$val * 8 + 106',
+    },{
+        Name => 'ExposureCompensationSet',
+        Notes => 'other models',
+        ValueConv => '($val - 128) / 24', #PH
+        ValueConvInv => 'int($val * 24 + 128.5)',
+        PrintConv => '$val ? sprintf("%+.1f",$val) : 0',
+        PrintConvInv => 'Image::ExifTool::Exif::ConvertFraction($val)',
+    }],
+    0x1f => [{
+        Name => 'ISO',
+        Condition => '$$self{Model} =~ /^DSLR-(A450|A500|A550)/',
+        Notes => 'A450, A500 and A550',
+        ValueConv => '$val ? exp(($val/8-6)*log(2))*100 : $val',
+        ValueConvInv => '$val ? 8*(log($val/100)/log(2)+6) : $val',
+        PrintConv => '$val ? sprintf("%.0f",$val) : "Auto"',
+        PrintConvInv => '$val =~ /auto/i ? 0 : $val',
+    },{
+        Name => 'FlashExposureCompSet',
+        Notes => 'other models',
+        Description => 'Flash Exposure Comp. Setting',
+        ValueConv => '($val - 128) / 24', #PH
+        ValueConvInv => 'int($val * 24 + 128.5)',
+        PrintConv => '$val ? sprintf("%+.1f",$val) : 0',
+        PrintConvInv => 'Image::ExifTool::Exif::ConvertFraction($val)',
+    }],
+    0x20 => [{
+        Name => 'FNumber',
+        Condition => '$$self{Model} =~ /^DSLR-(A450|A500|A550)/',
+        Notes => 'A450, A500 and A550',
+        ValueConv => '2 ** (($val/8 - 1) / 2)',
+        ValueConvInv => 'int((log($val) * 2 / log(2) + 1) * 8 + 0.5)',
+        PrintConv => 'Image::ExifTool::Exif::PrintFNumber($val)',
+        PrintConvInv => '$val',
+    },{
+        Name => 'LiveViewAFMethod',
+        Condition => '$$self{Model} !~ /^NEX-(3|5|5C)/',
+        Notes => 'other models except the NEX-3/5/5C',
+        PrintConv => {
+            0 => 'n/a',
+            1 => 'Phase-detect AF',
+            2 => 'Contrast AF',
+            # Contrast AF is only available with SSM/SAM lenses and in Focus Check LV,
+            # NOT in Quick AF LV, and is automatically set when mounting SSM/SAM lens
+            # - changes into Phase-AF when switching to Quick AF LV.
+        },
+    }],
+    0x21 => [{
+        Name => 'ExposureTime',
+        Condition => '$$self{Model} =~ /^DSLR-(A450|A500|A550)/',
+        Notes => 'A450, A500 and A550',
+        ValueConv => '$val ? 2 ** (6 - $val/8) : 0',
+        ValueConvInv => '$val ? int((6 - log($val) / log(2)) * 8 + 0.5) : 0',
+        PrintConv => '$val ? Image::ExifTool::Exif::PrintExposureTime($val) : "Bulb"',
+        PrintConvInv => 'lc($val) eq "bulb" ? 0 : Image::ExifTool::Exif::ConvertFraction($val)',
+    },{
+        Name => 'ISO',
+        Condition => '$$self{Model} =~ /^NEX-(3|5|5C)/',
+        Notes => 'NEX-3/5/5C',
+        ValueConv => '$val ? exp(($val/8-6)*log(2))*100 : $val',
+        ValueConvInv => '$val ? 8*(log($val/100)/log(2)+6) : $val',
+        PrintConv => '$val ? sprintf("%.0f",$val) : "Auto"',
+        PrintConvInv => '$val =~ /auto/i ? 0 : $val',
+    }],
+    0x22 => {
+        Name => 'FNumber',
+        Condition => '$$self{Model} =~ /^NEX-(3|5|5C)/',
+        Notes => 'NEX-3/5/5C only',
+        ValueConv => '2 ** (($val/8 - 1) / 2)',
+        ValueConvInv => 'int((log($val) * 2 / log(2) + 1) * 8 + 0.5)',
+        PrintConv => 'Image::ExifTool::Exif::PrintFNumber($val)',
+        PrintConvInv => '$val',
+    },
+    0x23 => [{
+        Name => 'FocalLength2',
+        Condition => '$$self{Model} =~ /^DSLR-(A450|A500|A550)/',
+        Notes => 'A450, A500 and A550',
+        ValueConv => '10 * 2 ** (($val-28)/16)',
+        ValueConvInv => '$val>0 ? log($val/10)/log(2) * 16 + 28 : 0',
+        PrintConv => 'sprintf("%.1f mm",$val)',
+        PrintConvInv => '$val=~s/\s*mm$//; $val',
+    },{
+        Name => 'ExposureTime',
+        Condition => '$$self{Model} =~ /^NEX-(3|5|5C)/',
+        Notes => 'NEX-3/5/5C',
+        ValueConv => '$val ? 2 ** (6 - $val/8) : 0',
+        ValueConvInv => '$val ? int((6 - log($val) / log(2)) * 8 + 0.5) : 0',
+        PrintConv => '$val ? Image::ExifTool::Exif::PrintExposureTime($val) : "Bulb"',
+        PrintConvInv => 'lc($val) eq "bulb" ? 0 : Image::ExifTool::Exif::ConvertFraction($val)',
+    }],
+    0x24 => {
+        Name => 'ExposureCompensation2',
+        Condition => '$$self{Model} =~ /^DSLR-(A450|A500|A550)/',
+        Notes => 'A450, A500 and A550',
+        Format => 'int16s',
+        ValueConv => '$val / 8',
+        ValueConvInv => '$val * 8',
+        PrintConv => '$val ? sprintf("%+.1f",$val) : 0',
+        PrintConvInv => '$val',
+    },
+    0x25 => [{
+        Name => 'FocalLength2',
+        Condition => '$$self{Model} =~ /^NEX-(3|5|5C)/',
+        Notes => 'NEX-3/5/5C',
+        ValueConv => '10 * 2 ** (($val-28)/16)',
+        ValueConvInv => '$val>0 ? log($val/10)/log(2) * 16 + 28 : 0',
+        PrintConv => 'sprintf("%.1f mm",$val)',
+        PrintConvInv => '$val=~s/\s*mm$//; $val',
+    },{
+        Name => 'ISO',
+        Condition => '$$self{Model} !~ /^DSLR-(A450|A500|A550)/',
+        Notes => 'other models except the A450, A500 and A550',
+        ValueConv => '$val ? exp(($val/8-6)*log(2))*100 : $val',
+        ValueConvInv => '$val ? 8*(log($val/100)/log(2)+6) : $val',
+        PrintConv => '$val ? sprintf("%.0f",$val) : "Auto"',
+        PrintConvInv => '$val =~ /auto/i ? 0 : $val',
+    }],
+    0x26 => [{
+        Name => 'FlashExposureCompSet2',
+        Description => 'Flash Exposure Comp. Setting 2',
+        Condition => '$$self{Model} =~ /^DSLR-(A450|A500|A550)/',
+        Notes => 'A450, A500 and A550',
+        Format => 'int16s',
+        ValueConv => '$val / 8',
+        ValueConvInv => '$val * 8',
+        PrintConv => '$val ? sprintf("%+.1f",$val) : 0',
+        PrintConvInv => '$val',
+    },{
+        Name => 'ExposureCompensation2',
+        Condition => '$$self{Model} =~ /^NEX-(3|5|5C)/',
+        Notes => 'NEX-3/5/5C',
+        Format => 'int16s',
+        ValueConv => '$val / 8',
+        ValueConvInv => '$val * 8',
+        PrintConv => '$val ? sprintf("%+.1f",$val) : 0',
+        PrintConvInv => '$val',
+    },{
+        Name => 'FNumber',
+        Notes => 'other models',
+        ValueConv => '2 ** (($val/8 - 1) / 2)',
+        ValueConvInv => 'int((log($val) * 2 / log(2) + 1) * 8 + 0.5)',
+        PrintConv => 'Image::ExifTool::Exif::PrintFNumber($val)',
+        PrintConvInv => '$val',
+    }],
+    0x27 => {
+        Name => 'ExposureTime',
+        Condition => '$$self{Model} !~ /^NEX-(3|5|5C)|DSLR-(A450|A500|A550)/',
+        Notes => 'models other than the A450, A500, A550 and NEX-3/5/5C',
+        ValueConv => '$val ? 2 ** (6 - $val/8) : 0',
+        ValueConvInv => '$val ? int((6 - log($val) / log(2)) * 8 + 0.5) : 0',
+        PrintConv => '$val ? Image::ExifTool::Exif::PrintExposureTime($val) : "Bulb"',
+        PrintConvInv => 'lc($val) eq "bulb" ? 0 : Image::ExifTool::Exif::ConvertFraction($val)',
+    },
+    0x28 => {
+        Name => 'Orientation2',
+        Condition => '$$self{Model} =~ /^DSLR-(A450|A500|A550)/',
+        Notes => 'A450, A500 and A550',
+        PrintConv => {
+            1 => 'Horizontal (normal)',
+            2 => 'Rotate 180',
+            6 => 'Rotate 90 CW',
+            8 => 'Rotate 270 CW',
+        },
+    },
+    0x29 => [{
+        # FocusPosition for A450/A500/A550
+        # seen values from 80 - 255 (= infinity) -- see Composite:FocusDistance2 below
+        Name => 'FocusPosition2',
+        Condition => '$$self{Model} =~ /^DSLR-(A450|A500|A550)/',
+        Notes => 'A450, A500 and A550',
+    },{
+        # value increase of 16 corresponds to doubling of FocalLength
+        Name => 'FocalLength2',
+        Condition => '$$self{Model} !~ /^NEX-(3|5|5C)/',
+        Notes => 'other models except the NEX-3/5/5C',
+        ValueConv => '10 * 2 ** (($val-28)/16)',
+        ValueConvInv => '$val>0 ? log($val/10)/log(2) * 16 + 28 : 0',
+        PrintConv => 'sprintf("%.1f mm",$val)',
+        PrintConvInv => '$val=~s/\s*mm$//; $val',
+    }],
+    0x2a => [{
+        Name => 'FlashAction',
+        Condition => '$$self{Model} =~ /^DSLR-(A450|A500|A550)/',
+        Notes => 'A450, A500 and A550',
+        PrintConv => {
+            0 => 'Did not fire',
+            1 => 'Fired',
+        },
+    },{
+        Name => 'ExposureCompensation2',
+        Condition => '$$self{Model} !~ /^NEX-(3|5|5C)/',
+        Notes => 'other models except the NEX-3/5/5C',
+        Format => 'int16s',
+        ValueConv => '$val / 8',
+        ValueConvInv => '$val * 8',
+        PrintConv => '$val ? sprintf("%+.1f",$val) : 0',
+        PrintConvInv => '$val',
+    }],
+    0x2b => {
+        # FocusPosition for NEX-3/5/5C
+        # seen values from 80 - 255 (= infinity) -- see Composite:FocusDistance2 below
+        Name => 'FocusPosition2',
+        Condition => '$$self{Model} =~ /^NEX-(3|5|5C)/',
+        Notes => 'NEX-3/5/5C only',
+    },
+    0x2c => [{
+        Name => 'FocusMode2',
+        Condition => '$$self{Model} =~ /^DSLR-(A450|A500|A550)/',
+        Notes => 'A450, A500 and A550',
+        PrintConv => {
+            0 => 'AF',
+            1 => 'MF',
+        },
+    },{
+        Name => 'FlashAction',
+        Condition => '$$self{Model} =~ /^NEX-(3|5|5C)/',
+        Notes => 'NEX-3/5/5C FlashAction2',
+        PrintConv => {
+            0 => 'Did not fire',
+            1 => 'Fired',
+        },
+    },{
+        Name => 'FlashExposureCompSet2',
+        Description => 'Flash Exposure Comp. Setting 2',
+        Notes => 'other models FlashExposureCompSet2',
+        Format => 'int16s',
+        ValueConv => '$val / 8',
+        ValueConvInv => '$val * 8',
+        PrintConv => '$val ? sprintf("%+.1f",$val) : 0',
+        PrintConvInv => '$val',
+    }],
+    0x2e => [{
+        Name => 'FocusMode2',
+        Condition => '$$self{Model} =~ /^NEX-(3|5|5C)/',
+        Notes => 'NEX-3/5/5C',
+        PrintConv => {
+            0 => 'AF',
+            1 => 'MF',
+        },
+    },{
+        Name => 'Orientation2', # seen some A55 images where this does not match the other Orientation tags
+        Condition => '$$self{Model} !~ /^DSLR-(A450|A500|A550)/',
+        Notes => 'other models except the A450, A500 and A550',
+        PrintConv => {
+            1 => 'Horizontal (normal)',
+            2 => 'Rotate 180',
+            6 => 'Rotate 90 CW',
+            8 => 'Rotate 270 CW',
+        },
+    }],
+    0x2f => {
+        # FocusPosition for A560/A580/A33/A35/A55V and NEX-C3/VG10/VG10E
+        # seen values from 80 - 255 (= infinity) -- see Composite:FocusDistance2 below
+        Name => 'FocusPosition2',
+        Condition => '$$self{Model} !~ /^NEX-(3|5|5C)|DSLR-(A450|A500|A550)/',
+        Notes => 'models other than the A450, A500, A550 and NEX-3/5/5C',
+    },
+    0x30 => {
+        Name => 'FlashAction',
+        Condition => '$$self{Model} !~ /^NEX-(3|5|5C)|DSLR-(A450|A500|A550)/',
+        Notes => 'models other than the A450, A500, A550 and NEX-3/5/5C',
+        PrintConv => {
+            0 => 'Did not fire',
+            1 => 'Fired',
+        },
+    },
+    0x32 => {
+        Name => 'FocusMode2',
+        Condition => '$$self{Model} !~ /^NEX-(3|5|5C)|DSLR-(A450|A500|A550)/',
+        Notes => 'models other than the A450, A500, A550 and NEX-3/5/5C',
+        PrintConv => {
+            0 => 'AF',
+            1 => 'MF',
+        },
+    },
+    0x0077 => {
+        Name => 'FlashAction2',
+        Condition => '$$self{Model} =~ /^DSLR-(A450|A500|A550)/',
+        PrintConv => {
+            0 => 'Did not fire',
+            2 => 'External Flash fired (2)',
+            3 => 'Built-in Flash fired',
+            4 => 'External Flash fired (4)', # what is difference with 2 ?
+        },
+    },
+    0x0078 => {
+        Name => 'FlashActionExternal',
+        Condition => '$$self{Model} =~ /^NEX-(3|5|5C)/',
+        PrintConv => {
+            136 => 'Did not fire',
+            121 => 'Fired', # what is difference with 122 ?
+            122 => 'Fired',
+        },
+    },
+    0x007c => {
+        Name => 'FlashActionExternal',
+        Condition => '$$self{Model} !~ /^NEX-(3|5|5C)|DSLR-(A450|A500|A550)/',
+        PrintConv => {
+            136 => 'Did not fire',
+            167 => 'Fired',
+            182 => 'Fired, HSS',
+        },
+    },
+    0x0082 => {
+        Name => 'FlashStatus',
+        Condition => '$$self{Model} =~ /^NEX-(3|5|5C)/',
+        PrintConv => {
+            0 => 'None',
+            2 => 'External',
+        },
+    },
+    0x0086 => {
+        Name => 'FlashStatus',
+        Condition => '$$self{Model} !~ /^NEX-(3|5|5C)|DSLR-(A450|A500|A550)/',
+        PrintConv => {
+            0 => 'None',
+            1 => 'Built-in',
+            2 => 'External',
+        },
+    },
+);
+
+# Face detection information (ref JR)
+my %faceInfo = (
+    Format => 'int16u[4]',
+    # re-order to top,left,height,width and scale to full-sized image like other Sony models
+    ValueConv => 'my @v=split(" ",$val); $_*=15 foreach @v; "$v[1] $v[0] $v[3] $v[2]"',
+    ValueConvInv => 'my @v=split(" ",$val); $_=int($_/15+0.5) foreach @v; "$v[1] $v[0] $v[3] $v[2]"',
+);
+%Image::ExifTool::Sony::FaceInfo = (
+    %binaryDataAttrs,
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    FORMAT => 'int16u',
+    DATAMEMBER => [ 0x00 ],
+    0x00 => {
+        Name => 'FacesDetected',
+        DataMember => 'FacesDetected',
+        Format => 'int16s',
+        RawConv => '$$self{FacesDetected} = ($val == -1 ? 0 : $val); $val',
+        PrintConv => {
+            OTHER => sub { shift }, # pass other values straight through
+            -1 => 'n/a',
+        },
+    },
+    0x01 => {
+        Name => 'Face1Position',
+        Condition => '$$self{FacesDetected} >= 1',
+        %faceInfo,
+        Notes => q{
+            re-ordered and scaled to return the top, left, height and width of detected
+            face, with coordinates relative to the full-sized unrotated image and
+            increasing Y downwards
+        },
+    },
+    0x06 => {
+        Name => 'Face2Position',
+        Condition => '$$self{FacesDetected} >= 2',
+        %faceInfo,
+    },
+    0x0b => {
+        Name => 'Face3Position',
+        Condition => '$$self{FacesDetected} >= 3',
+        %faceInfo,
+    },
+    0x10 => {
+        Name => 'Face4Position',
+        Condition => '$$self{FacesDetected} >= 4',
+        %faceInfo,
+    },
+    0x15 => {
+        Name => 'Face5Position',
+        Condition => '$$self{FacesDetected} >= 5',
+        %faceInfo,
+    },
+    0x1a => {
+        Name => 'Face6Position',
+        Condition => '$$self{FacesDetected} >= 6',
+        %faceInfo,
+    },
+    0x1f => {
+        Name => 'Face7Position',
+        Condition => '$$self{FacesDetected} >= 7',
+        %faceInfo,
+    },
+    0x24 => {
+        Name => 'Face8Position',
+        Condition => '$$self{FacesDetected} >= 8',
+        %faceInfo,
+    },
+);
+
+%Image::ExifTool::Sony::FaceInfoA = ( # different offsets for A450/A500/A550
+    %binaryDataAttrs,
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    FORMAT => 'int16u',
+    DATAMEMBER => [ 0x02, 0x03, 0x08 ],
+#
+# The FacesDetected number at 0x03 below is often 1 lower than the one at Tag900b 0x02.
+# The number of Face Positions starting at 0x5b (max. 4) corresponds to the number at 0x03.
+# The number of Face Positions starting at 0x0b usually corresponds to the FacesDetected number of Tag900b...
+# Therefore created the extra condition at 0x0b (11.1) to output an available FacePosition, even when 0x03=0...
+#
+    0x02 => {
+        Name => 'FaceTest2',
+        DataMember => 'FaceTest2',
+        Hidden => 1,
+        RawConv => '$$self{FaceTest2} = $val; $$self{OPTIONS}{Unknown}<2 ? undef : $val',
+    },
+    0x03 => {
+        Name => 'FacesDetected',
+        DataMember => 'FacesDetected',
+        RawConv => '$$self{FacesDetected} = ($val > 8 ? 0 : $val); $val',
+        ValueConv => '$val > 8 ? 0 : $val',
+    },
+    0x08 => {
+        Name => 'FaceTest8',
+        DataMember => 'FaceTest8',
+        Hidden => 1,
+        RawConv => '$$self{FaceTest8} = $val; $$self{OPTIONS}{Unknown}<2 ? undef : $val',
+    },
+# 0x0b - start of 8 Face Positions of 10 int16u values each
+    0x0b => {
+        Name => 'PotentialFace1Position',
+        Condition => q{
+            $$self{FacesDetected} >= 1 or
+            ($$self{FaceTest8} > 0 and ($$self{FaceTest2} == 1 or $$self{FaceTest2} == 257))
+        },
+        %faceInfo,
+    },
+    0x15 => {
+        Name => 'PotentialFace2Position',
+        Condition => '$$self{FacesDetected} >= 2 or ($$self{FacesDetected} == 1 and $$self{FaceTest8} > 0)',
+        %faceInfo,
+    },
+    0x1f => {
+        Name => 'PotentialFace3Position',
+        Condition => '$$self{FacesDetected} >= 3 or ($$self{FacesDetected} == 2 and $$self{FaceTest8} > 0)',
+        %faceInfo,
+    },
+    0x29 => {
+        Name => 'PotentialFace4Position',
+        Condition => '$$self{FacesDetected} >= 4 or ($$self{FacesDetected} == 3 and $$self{FaceTest8} > 0)',
+        %faceInfo,
+    },
+    0x33 => {
+        Name => 'PotentialFace5Position',
+        Condition => '$$self{FacesDetected} >= 5 or ($$self{FacesDetected} == 4 and $$self{FaceTest8} > 0)',
+        %faceInfo,
+    },
+    0x3d => {
+        Name => 'PotentialFace6Position',
+        Condition => '$$self{FacesDetected} >= 6 or ($$self{FacesDetected} == 5 and $$self{FaceTest8} > 0)',
+        %faceInfo,
+    },
+    0x47 => {
+        Name => 'PotentialFace7Position',
+        Condition => '$$self{FacesDetected} >= 7 or ($$self{FacesDetected} == 6 and $$self{FaceTest8} > 0)',
+        %faceInfo,
+    },
+    0x51 => {
+        Name => 'PotentialFace8Position',
+        Condition => '$$self{FacesDetected} >= 8 or ($$self{FacesDetected} == 7 and $$self{FaceTest8} > 0)',
+        %faceInfo,
+    },
+# 0x5b - start of max. 4 further Face Positions here
+    0x5b => {
+        Name => 'Face1Position',
+        Condition => '$$self{FacesDetected} >= 1',
+        %faceInfo,
+    },
+    0x65 => {
+        Name => 'Face2Position',
+        Condition => '$$self{FacesDetected} >= 2',
+        %faceInfo,
+    },
+    0x6f => {
+        Name => 'Face3Position',
+        Condition => '$$self{FacesDetected} >= 3',
+        %faceInfo,
+    },
+    0x79 => {
+        Name => 'Face4Position',
+        Condition => '$$self{FacesDetected} >= 4',
+        %faceInfo,
+    },
+);
+
+# Camera settings (ref PH) (decoded mainly from A200)
+%Image::ExifTool::Sony::CameraSettings = (
+    %binaryDataAttrs,
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    FORMAT => 'int16u',
+    PRIORITY => 0,
+    NOTES => 'Camera settings for the A200, A300, A350, A700, A850 and A900.',
+    0x00 => { #JR
+        Name => 'ExposureTime',
+        ValueConv => '$val ? 2 ** (6 - $val/8) : 0',
+        ValueConvInv => '$val ? int((6 - log($val) / log(2)) * 8 + 0.5) : 0',
+        PrintConv => '$val ? Image::ExifTool::Exif::PrintExposureTime($val) : "Bulb"',
+        PrintConvInv => 'lc($val) eq "bulb" ? 0 : Image::ExifTool::Exif::ConvertFraction($val)',
+    },
+    0x01 => { #JR
+        Name => 'FNumber',
+        ValueConv => '2 ** (($val/8 - 1) / 2)',
+        ValueConvInv => 'int((log($val) * 2 / log(2) + 1) * 8 + 0.5)',
+        PrintConv => 'Image::ExifTool::Exif::PrintFNumber($val)',
+        PrintConvInv => '$val',
+    },
+    0x02 => { #JR (requires external flash)
+        Name => 'HighSpeedSync',
+        PrintConv => {
+            0 => 'Off',
+            1 => 'On',
+        },
+    },
+    0x03 => { #JR
+        Name => 'ExposureCompensationSet',
+        ValueConv => '($val - 128) / 24',
+        ValueConvInv => 'int($val * 24 + 128.5)',
+        PrintConv => '$val ? sprintf("%+.1f",$val) : 0',
+        PrintConvInv => 'Image::ExifTool::Exif::ConvertFraction($val)',
+    },
+    0x04 => { #7/JR
+        Name => 'DriveMode',
+        Mask => 0xff, # (not sure what upper byte is for)
+        PrintHex => 1,
+        PrintConv => {
+            0x01 => 'Single Frame',
+            0x02 => 'Continuous High', # A700/A900; not on A850
+            0x12 => 'Continuous Low', #JR
+            0x04 => 'Self-timer 10 sec',
+            0x05 => 'Self-timer 2 sec, Mirror Lock-up',
+            0x06 => 'Single-frame Bracketing',
+            0x07 => 'Continuous Bracketing', # (A200 val=0x1107)
+            0x18 => 'White Balance Bracketing Low', #JR
+            0x28 => 'White Balance Bracketing High', #JR
+            0x19 => 'D-Range Optimizer Bracketing Low', #JR
+            0x29 => 'D-Range Optimizer Bracketing High', #JR
+            0x0a => 'Remote Commander', #JR
+            0x0b => 'Mirror Lock-up', #JR (A850/A900; not on A700)
+        },
+    },
+    0x05 => { #JR
+        Name => 'WhiteBalanceSetting',
+        PrintConv => {
+            2 => 'Auto',
+            4 => 'Daylight',
+            5 => 'Fluorescent',
+            6 => 'Tungsten',
+            7 => 'Flash',
+            16 => 'Cloudy',
+            17 => 'Shade',
+            18 => 'Color Temperature/Color Filter',
+            32 => 'Custom 1',
+            33 => 'Custom 2',
+            34 => 'Custom 3',
+        },
+    },
+    0x06 => { #7 (A700) (ref JR: at least also valid for A200, ValueConv as for ColorCompensationFilterSet)
+        Name => 'WhiteBalanceFineTune',
+        ValueConv => '$val > 128 ? $val - 256 : $val',
+        ValueConvInv => '$val < 0 ? $val + 256 : $val',
+    },
+    0x07 => { #JR as set in WB "Color Temperature/Color Filter" and in White Balance Bracketing
+        Name => 'ColorTemperatureSet',
+        ValueConv => '$val * 100',
+        ValueConvInv => '$val / 100',
+        PrintConv => '"$val K"',
+        PrintConvInv => '$val =~ s/ ?K$//i; $val',
+    },
+    0x08 => { #JR as set in WB "Color Temperature/Color Filter"
+        Name => 'ColorCompensationFilterSet',
+        Notes => 'negative is green, positive is magenta',
+        ValueConv => '$val > 128 ? $val - 256 : $val',
+        ValueConvInv => '$val < 0 ? $val + 256 : $val',
+        PrintConv => '$val > 0 ? "+$val" : $val',
+        PrintConvInv => '$val',
+    },
+    0x0c => { #JR as set in WB "Custom" and in White Balance Bracketing
+        Name => 'ColorTemperatureCustom',
+        ValueConv => '$val * 100',
+        ValueConvInv => '$val / 100',
+        PrintConv => '"$val K"',
+        PrintConvInv => '$val =~ s/ ?K$//i; $val',
+    },
+    0x0d => { #JR as set in WB "Custom"
+        Name => 'ColorCompensationFilterCustom',
+        Notes => 'negative is green, positive is magenta',
+        ValueConv => '$val > 128 ? $val - 256 : $val',
+        ValueConvInv => '$val < 0 ? $val + 256 : $val',
+        PrintConv => '$val > 0 ? "+$val" : $val',
+        PrintConvInv => '$val',
+    },
+    0x0f => { #JR
+        Name => 'WhiteBalance',
+        PrintConv => {
+            2 => 'Auto',
+            4 => 'Daylight',
+            5 => 'Fluorescent',
+            6 => 'Tungsten',
+            7 => 'Flash',
+            12 => 'Color Temperature',
+            13 => 'Color Filter',
+            14 => 'Custom',
+            16 => 'Cloudy',
+            17 => 'Shade',
+        },
+    },
+    0x10 => { #7 (A700)
+        Name => 'FocusModeSetting',
+        PrintConv => {
+            0 => 'Manual',
+            1 => 'AF-S',
+            2 => 'AF-C',
+            3 => 'AF-A',
+            4 => 'DMF', #JR
+        },
+    },
+    0x11 => { #JD (A700)
+        Name => 'AFAreaMode',
+        PrintConv => {
+            0 => 'Wide',
+            1 => 'Local',
+            2 => 'Spot',
+        },
+    },
+    0x12 => { #7 (A700)
+        Name => 'AFPointSetting',
+        Format => 'int16u',
+        # The AF point as selected by the user in AFAreaMode=Local or Spot;
+        # Reported value remains at the last-set position in AFAreaModes=Wide.
+        # A200, A300, A350: 9-point centre-cross (ref JR)
+        # A700: 11-point centre-dual-cross (ref JR)
+        # A850, A900: 9-point centre-dual-cross with 10 assist-points (ref JR)
+        PrintConvColumns => 2,
+        PrintConv => {
+            1 => 'Center',
+            2 => 'Top',
+            3 => 'Upper-right',
+            4 => 'Right',
+            5 => 'Lower-right',
+            6 => 'Bottom',
+            7 => 'Lower-left',
+            8 => 'Left',
+            9 => 'Upper-left',
+            10 => 'Far Right', # (presumably A700 only)
+            11 => 'Far Left', # (presumably A700 only)
+        },
+    },
+    0x13 => { #JR
+        Name => 'FlashMode',
+        PrintConv => {
+            0 => 'Autoflash',
+            2 => 'Rear Sync',
+            3 => 'Wireless',
+            4 => 'Fill-flash',
+            5 => 'Flash Off',
+            6 => 'Slow Sync',
+        },
+    },
+    0x14 => { #JR
+        Name => 'FlashExposureCompSet',
+        Description => 'Flash Exposure Comp. Setting',
+        # (as pre-selected by the user, not zero if flash didn't fire)
+        ValueConv => '($val - 128) / 24', #PH
+        ValueConvInv => 'int($val * 24 + 128.5)',
+        PrintConv => '$val ? sprintf("%+.1f",$val) : 0',
+        PrintConvInv => 'Image::ExifTool::Exif::ConvertFraction($val)',
+    },
+    0x15 => { #7
+        Name => 'MeteringMode',
+        PrintConv => {
+            1 => 'Multi-segment',
+            2 => 'Center-weighted average',
+            4 => 'Spot',
+        },
+    },
+    0x16 => {
+        Name => 'ISOSetting',
+        # 0 indicates 'Auto' (I think)
+        ValueConv => '$val ? exp(($val/8-6)*log(2))*100 : $val',
+        ValueConvInv => '$val ? 8*(log($val/100)/log(2)+6) : $val',
+        PrintConv => '$val ? sprintf("%.0f",$val) : "Auto"',
+        PrintConvInv => '$val =~ /auto/i ? 0 : $val',
+    },
+    0x18 => { #7
+        Name => 'DynamicRangeOptimizerMode',
+        PrintConv => {
+            0 => 'Off',
+            1 => 'Standard',
+            2 => 'Advanced Auto',
+            3 => 'Advanced Level',
+        },
+    },
+    0x19 => { #7
+        Name => 'DynamicRangeOptimizerLevel',
+    },
+    0x1a => { # style actually used (combination of mode dial + creative style menu)
+        Name => 'CreativeStyle',
+        PrintConvColumns => 2,
+        PrintConv => {
+            1 => 'Standard',
+            2 => 'Vivid',
+            3 => 'Portrait',
+            4 => 'Landscape',
+            5 => 'Sunset',
+            6 => 'Night View/Portrait',
+            8 => 'B&W',
+            9 => 'Adobe RGB', # A700
+            11 => 'Neutral',
+            12 => 'Clear', #7
+            13 => 'Deep', #7
+            14 => 'Light', #7
+            15 => 'Autumn Leaves', #7
+            16 => 'Sepia', #7
+        },
+    },
+    0x1b => { #JR
+        Name => 'ColorSpace',
+        PrintConv => {
+            0 => 'sRGB',
+            1 => 'Adobe RGB',        # (A850, selected via Colorspace menu item)
+            5 => 'Adobe RGB (A700)', # (A700, selected via CreativeStyle menu)
         },
     },
